/**
 * JunQTMacOSXUtils.m:
 *
 * 	@author:	Hoshi Takanori
 * 	@version:	1.0
 * 	@updated:	2004/01/09 (by Hoshi Takanori)
 *
 * 	$Id: JunQTMacOSXUtils.m,v 1.2 2004/02/19 07:08:21 hoshi Exp $
 */

#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>

#include <jawt.h>
#include <jawt_md.h>


/*
 * functions
 */

NSQuickDrawView *JunMacOSX_CreatePortAssociation1(void *platformInfo)
{
	JAWT_MacOSXDrawingSurfaceInfo *pi;
	NSRect rect;
	NSQuickDrawView *view;

	pi = (JAWT_MacOSXDrawingSurfaceInfo *) platformInfo;

	rect = NSMakeRect(0, 0, 0, 0);
	view = [[NSQuickDrawView alloc] initWithFrame: rect];
	[pi->cocoaViewRef addSubview: view];
	[view release];

	return view;
}

CGrafPtr JunMacOSX_CreatePortAssociation2(NSQuickDrawView *view)
{
	GrafPtr port;

	[view lockFocus];
	port = [view qdPort];
	[view unlockFocus];

	return port;
}

void JunMacOSX_DestroyPortAssociation(NSQuickDrawView *view)
{
	if (view != nil) {
		[view removeFromSuperview];
	}
}
