package sra.jun.csg.compound;

import sra.jun.csg.abstracts.JunBinaryCSG;
import sra.jun.geometry.basic.Jun3dPoint;
import sra.jun.solid.abstracts.JunSolid;

/**
 * JunCSGUnion class
 * 
 *  @author    nisinaka
 *  @created   1998/10/18 (by nisinaka)
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on JunXXX for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCSGUnion.java,v 6.5 2004/04/15 06:27:50 nisinaka Exp $
 */
public class JunCSGUnion extends JunBinaryCSG {

	/**
	 * Create a new instance of JunCSGUnion.
	 * 
	 * @param aSolid1 sra.jun.solid.abstracts.JunSolid
	 * @param aSolid2 sra.jun.solid.abstracts.JunSolid
	 */
	public JunCSGUnion(JunSolid aSolid1, JunSolid aSolid2) {
		super(aSolid1, aSolid2);
	}

	/**
	 * Answer a value at the specified point.
	 * 
	 * @param aJun3dPoint sra.jun.geometry.basic.Jun3dPoint
	 * 
	 * @return double
	 */
	public double valueAt_(Jun3dPoint aJun3dPoint) {
		return Math.max(solid1.valueAt_(aJun3dPoint), solid2.valueAt_(aJun3dPoint));
	}
}
