package sra.jun.geometry.abstracts;

import sra.jun.geometry.curves.JunNurbsCurve;
import sra.smalltalk.SmalltalkException;

/**
 * JunCurve class
 * 
 *  @author    nisinaka
 *  @created   1998/09/29 (by nisinaka)
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on Jun508 for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCurve.java,v 6.5 2004/04/15 06:27:51 nisinaka Exp $
 */
public abstract class JunCurve extends JunGeometry {

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @return JunNurbsCurve
	 * 
	 * @category converting
	 */
	public JunNurbsCurve asNurbsCurve() {
		throw SmalltalkException.SubclassResponsibility();
	}

	/**
	 * Answer true if this is a kind of Curve geometry object, otherwise false.
	 * 
	 * @return boolean
	 * 
	 * @category testing
	 */
	public boolean isCurve() {
		return true;
	}
}
