package sra.jun.geometry.basic;

import sra.jun.geometry.abstracts.*;

/**
 * JunBoundingBox class
 * 
 *  @author    nisinaka
 *  @created   1998/10/01 (by nisinaka)
 *  @updated   1999/08/05 (by nisinaka)
 *  @updated   2000/01/06 (by nisinaka)
 *  @version   445 (with StPL6.5) based on JunXXX for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBoundingBox.java,v 6.5 2004/04/15 06:27:52 nisinaka Exp $
 */
public abstract class JunBoundingBox extends JunGeometry {

	/**
	 * Answer the depth of the receiver.
	 * 
	 * @return double
	 * 
	 * @category accessing
	 */
	public abstract double depth();

	/**
	 * Answer the height of the receiver.
	 * 
	 * @return double
	 * 
	 * @category accessing
	 */
	public abstract double height();

	/**
	 * Answer the width of the receiver.
	 * 
	 * @return double
	 * 
	 * @category accessing
	 */
	public abstract double width();

}
