package sra.jun.geometry.transformations;

import sra.jun.collections.sequences.*;
import sra.jun.geometry.abstracts.*;

/**
 * JunTransformation class
 * 
 *  @author    nisinaka
 *  @created   1998/09/28 (by nisinaka)
 *  @updated   2000/01/06 (by nisinaka)
 *  @version   445 (with StPL6.5) based on JunXXX for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTransformation.java,v 6.6 2004/04/15 06:27:53 nisinaka Exp $
 */
public abstract class JunTransformation extends JunGeometry {

	/**
	 * Convert this transformation as an array.
	 * 
	 * @return double[]
	 * @category converting
	 */
	public abstract double[] asArray();

	/**
	 * Convert this transformation as a matrix.
	 * 
	 * @return sra.jun.collections.sequences.JunDoubleMatrix
	 * @category converting
	 */
	public abstract JunDoubleMatrix asMatrix();
}
