package sra.jun.goodies.button;

import java.awt.*;
import sra.smalltalk.StView;

/**
 * JunButtonView interface
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   1999/11/12 (by MATSUDA Ryouichi)
 *  @updated   2002/11/21 (by nisinaka)
 *  @updated   2003/03/24 (by nisinaka)
 *  @version   445 (with StPL6.5) based on Jun472 for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunButtonView.java,v 6.6 2004/04/15 06:27:54 nisinaka Exp $
 */
public interface JunButtonView extends StView {

	public static final Color Gray20 = new Color((float) 0.2, (float) 0.2, (float) 0.2);
	public static final Color Gray30 = new Color((float) 0.3, (float) 0.3, (float) 0.3);
	public static final Color Gray70 = new Color((float) 0.7, (float) 0.7, (float) 0.7);
	public static final Color Gray80 = new Color((float) 0.8, (float) 0.8, (float) 0.8);
	public static final Color Gray90 = new Color((float) 0.9, (float) 0.9, (float) 0.9);

	/**
	 * Answer my model as JunButtonModel.
	 * 
	 * @return sra.jun.goodies.JunButtonModel
	 * @category accessing
	 */
	public JunButtonModel getButtonModel();

	/**
	 * Update the view when the value of the model is true.
	 * 
	 * @param aGraphics java.awt.Graphics
	 * @category displaying
	 */
	public void displayTrueOn_(Graphics aGraphics);

	/**
	 * Update the view when the value of the model is false.
	 * 
	 * @param aGraphics java.awt.Graphics
	 * @category displaying
	 */
	public void displayFalseOn_(Graphics aGraphics);

}
