package sra.jun.goodies.calendar;

import java.util.Calendar;

import sra.jun.goodies.milliseconds.JunMillisecondModel;
import sra.jun.system.support.JunTestExamples;
import sra.smalltalk.StBlockClosure;

/**
 * JunCalendarClockDateAndTimeTestExamples class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on Jun472 for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarClockDateAndTimeTestExamples.java,v 6.7 2004/04/15 06:27:55 nisinaka Exp $
 */
public class JunCalendarClockDateAndTimeTestExamples extends JunTestExamples {
	/**
	 * Example2: time stamp output for 10 seconds.
	 *
	 * @return boolean
	 */
	public static boolean Example2() {
		JunCalendarClockDateAndTime calendarClock = new JunCalendarClockDateAndTime();
		calendarClock.compute_(new StBlockClosure() {
			public Object value_(Object o) {
				Calendar cal = (Calendar) o;
				int year = cal.get(Calendar.YEAR);
				int month = cal.get(Calendar.MONTH);
				int day = cal.get(Calendar.DATE);
				int hour = cal.get(Calendar.HOUR);
				int minute = cal.get(Calendar.MINUTE);
				int second = cal.get(Calendar.SECOND);
				int[] ampm = { 0, 12 };
				hour += ampm[cal.get(Calendar.AM_PM)];
				System.out.println(
					(month + 1)
						+ " "
						+ day
						+ ","
						+ year
						+ " "
						+ hour
						+ ":"
						+ minute
						+ ":"
						+ second);
				return null;
			}
		});
		long endTime = calendarClock.nextMillisecondClockValue() + 10000;
		JunMillisecondModel time = new JunMillisecondModel();
		time.nowValue();
		while (time.milliseconds() < endTime) {
			time.nowValue();
		}
		calendarClock.release();
		return true;
	}

	/**
	 * Example1: Open a JunCalendarDateAndTime.
	 *
	 * @return boolean
	 */
	public static boolean Example1() {
		JunCalendarClockDateAndTime calendarClock = new JunCalendarClockDateAndTime();
		calendarClock.open();
		return true;
	}

	/**
	 * Execute all examples.
	 *
	 * @param args an array of command-line arguments
	 */
	public static void main(String argv[]) {
		new JunCalendarClockDateAndTimeTestExamples();
	}
}
