package sra.jun.goodies.calendar;

import java.awt.Dimension;

import sra.smalltalk.StViewJPanel;
import sra.smalltalk.WindowSpecLayout;

/**
 * JunCalendarClockDateViewSwing class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on Jun472 for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarClockDateViewSwing.java,v 6.6 2004/04/15 06:27:55 nisinaka Exp $
 */
public class JunCalendarClockDateViewSwing
	extends StViewJPanel
	implements JunCalendarClockDateView {
	protected JunCalendarDateViewSwing dateView;
	/**
	 * Create instance.
	 *
	 * @param aCalendarClockDate JunCalendarClockDate
	 * @category instance creation
	 */
	public JunCalendarClockDateViewSwing(JunCalendarClockDate aCalendarClockDate) {
		super(aCalendarClockDate);
	}

	/**
	 * Answer my date view.
	 *
	 * @return JunCalendarDateViewSwing
	 * @category defaults
	 */
	public JunCalendarDateViewSwing dateView() {
		if (dateView == null) {
			dateView =
				new JunCalendarDateViewSwing(this.getModel().calendarDateModel());
		}
		return dateView;
	}

	/**
	* Get model.
	*
	* @return JunCalendarTimeModel
	* @category accessomg
	*/
	public JunCalendarClockDate getModel() {
		return (JunCalendarClockDate) this.model();
	}

	/**
	 * Build this component.
	 * @category interface opening
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.dateView(), WindowSpecLayout.Position(0f, 1, 0f, 1, 1f, -1, 1f, -1));
		this.setPreferredSize(new Dimension(300, 200));
	}

}
