package sra.jun.goodies.calendar;

import sra.jun.system.support.JunSystem;
import sra.smalltalk.StView;

/**
 * JunCalendarClockTime class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on Jun472 for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarClockTime.java,v 6.7 2004/04/15 06:27:55 nisinaka Exp $
 */
public class JunCalendarClockTime extends JunCalendarClockDateAndTime {
	/**
	 * Default view.
	 *
	 * @return sra.smalltalk.StView
	 * @category defaults
	 */
	public StView defaultView() {
		JunCalendarClockTimeView aView;
		if (GetDefaultViewMode() == VIEW_AWT) {
			aView = new JunCalendarClockTimeViewAwt(this);
		} else {
			aView = new JunCalendarClockTimeViewSwing(this);
		}
		return aView;
	}

	/**
	 * Return window title.
	 *
	 * @return java.lang.String
	 * @category interface opening
	 */
	protected String windowTitle() {
		return JunSystem.$String("HHMMSS", "Time");
	}
}
