package sra.jun.goodies.calendar;

import java.util.Calendar;
import sra.jun.system.support.JunTestExamples;

/**
 * JunCalendarDateAndTimeIntervalModelTestExamples class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on Jun472 for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarDateAndTimeIntervalModelTestExamples.java,v 6.7 2004/04/15 06:27:55 nisinaka Exp $
 */
public class JunCalendarDateAndTimeIntervalModelTestExamples
	extends JunTestExamples {
	/**
	 * Example1: Open a JunCalendarDateAndTimeIntervalModel.
	 *
	 * @return boolean
	 */
	public static boolean Example1() {
		JunCalendarDateAndTimeIntervalModel calendarDateAndTimeIntervalModel =
			new JunCalendarDateAndTimeIntervalModel();
		calendarDateAndTimeIntervalModel.open();
		return true;
	}

	/**
	 * Example2: Set time and open a JunCalendarDateAndTimeIntervalModel.
	 *
	 * @return boolean
	 */
	public static boolean Example2() {
		Calendar[] now = { Calendar.getInstance(), Calendar.getInstance()};
		Calendar[] after = {Calendar.getInstance(), Calendar.getInstance()};
		after[0].add(Calendar.DATE, 7);
		after[1].add(Calendar.SECOND, 60);
		int[] ampm = { 0, 12 };
		JunCalendarDateAndTimeIntervalModel calendarDateAndTimeIntervalModel = JunCalendarDateAndTimeIntervalModel.From_to_(now, after);
		System.out.println(calendarDateAndTimeIntervalModel);
		return true;
	}

	/**
	 * Execute all examples.
	 *
	 * @param args an array of command-line arguments
	 */
	public static void main(String argv[]) {
		new JunCalendarDateAndTimeIntervalModelTestExamples();
	}
}
