package sra.jun.goodies.calendar;

import sra.smalltalk.StViewPanel;
import sra.smalltalk.WindowSpecLayout;

/**
 * JunCalendarDateAndTimeIntervalViewAwt class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on Jun472 for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarDateAndTimeIntervalViewAwt.java,v 6.7 2004/04/15 06:27:55 nisinaka Exp $
 */
public class JunCalendarDateAndTimeIntervalViewAwt
	extends StViewPanel
	implements JunCalendarDateAndTimeIntervalView {
	protected JunCalendarDateViewAwt fromDateView;
	protected JunCalendarTimeViewAwt fromTimeView;
	protected JunCalendarDateViewAwt toDateView;
	protected JunCalendarTimeViewAwt toTimeView;
	/**
	 * Create instance.
	 *
	 * @param aCalendarDateAndTimeInterval JunCalendarDateAndTimeInterval
	 * @category instance creation
	 */
	public JunCalendarDateAndTimeIntervalViewAwt(JunCalendarDateAndTimeIntervalModel aCalendarDateAndTimeIntervalModel) {
		super(aCalendarDateAndTimeIntervalModel);
	}

	/**
	 * Answer my date view.
	 *
	 * @return JunCalendarDateViewAwt
	 * @category accessing
	 */
	public JunCalendarDateViewAwt fromDateView() {
		if (fromDateView == null) {
			fromDateView =
				new JunCalendarDateViewAwt(this.getModel().fromCalendarDateAndTimeModel().calendarDateModel());
		}
		return fromDateView;
	}

	/**
	 * Answer my time view.
	 *
	 * @return JunCalendarTimeViewAwt
	 * @category accessing
	 */
	public JunCalendarTimeViewAwt fromTimeView() {
		if (fromTimeView == null) {
			fromTimeView =
				new JunCalendarTimeViewAwt(this.getModel().fromCalendarDateAndTimeModel().calendarTimeModel());
		}
		return fromTimeView;
	}

	/**
	 * Answer my date view.
	 *
	 * @return JunCalendarDateViewAwt
	 * @category accessing
	 */
	public JunCalendarDateViewAwt toDateView() {
		if (toDateView == null) {
			toDateView =
				new JunCalendarDateViewAwt(this.getModel().toCalendarDateAndTimeModel().calendarDateModel());
		}
		return toDateView;
	}

	/**
	 * Answer my time view.
	 *
	 * @return JunCalendarTimeViewAwt
	 * @category accessing
	 */
	public JunCalendarTimeViewAwt toTimeView() {
		if (toTimeView == null) {
			toTimeView =
				new JunCalendarTimeViewAwt(this.getModel().toCalendarDateAndTimeModel().calendarTimeModel());
		}
		return toTimeView;
	}

	/**
	* Get model.
	*
	* @return JunCalendarDateAndTimeModel
	* @category accessing
	*/
	public JunCalendarDateAndTimeIntervalModel getModel() {
		return (JunCalendarDateAndTimeIntervalModel) this.model();
	}

	/**
	 * Build this component.
	 * @category interface opening
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.fromDateView(), WindowSpecLayout.Position(0f, 1, 0f, 1, 0.67f, 0, 0.5f, 0));
		this.add(this.fromTimeView(), WindowSpecLayout.Position(0.67f, 0, 0f, 1, 1f, -1, 0.5f, 0));
		this.add(this.toDateView(), WindowSpecLayout.Position(0f, 1, 0.5f, 0, 0.67f, 0, 1f, -1));
		this.add(this.toTimeView(), WindowSpecLayout.Position(0.67f, 0, 0.5f, 0, 1f, -1, 1f, -1));
		this.setSize(450, 400);
	}
}
