package sra.jun.goodies.calendar;

import sra.smalltalk.StViewPanel;
import sra.smalltalk.WindowSpecLayout;

/**
 * JunCalendarDateIntervalViewAwt class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on Jun472 for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarDateIntervalViewAwt.java,v 6.7 2004/04/15 06:27:55 nisinaka Exp $
 */
public class JunCalendarDateIntervalViewAwt
	extends StViewPanel
	implements JunCalendarDateIntervalView {
	protected JunCalendarDateViewAwt fromView;
	protected JunCalendarDateViewAwt toView;
	/**
	 * Create instance.
	 *
	 * @param aCalendarDateInterval JunCalendarDateInterval
	 * @category instance creation
	 */
	public JunCalendarDateIntervalViewAwt(JunCalendarDateIntervalModel aCalendarDateIntervalModel) {
		super(aCalendarDateIntervalModel);
	}

	/**
	 * Answer a fromView.
	 *
	 * @return JunCalendarDateViewAwt
	 * @category accessing
	 */
	public JunCalendarDateViewAwt fromView() {
		if (fromView == null) {
			fromView =
				new JunCalendarDateViewAwt(
					this.getModel().fromCalendarDateModel());
		}
		return fromView;
	}

	/**
	 * Answer a toView.
	 *
	 * @return JunCalendarDateViewAwt
	 * @category accessing
	 */
	public JunCalendarDateViewAwt toView() {
		if (toView == null) {
			toView =
				new JunCalendarDateViewAwt(
					this.getModel().toCalendarDateModel());
		}
		return toView;
	}

	/**
	* Get model.
	*
	* @return JunCalendarDateModel
	 * @category accessing
	*/
	public JunCalendarDateIntervalModel getModel() {
		return (JunCalendarDateIntervalModel) this.model();
	}

	/**
	 * Build this component.
	 * @category interface opening
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.fromView(), WindowSpecLayout.Position(0f, 1, 0f, 1, 1f, -1, 0.5f, -1));
		this.add(this.toView(), WindowSpecLayout.Position(0f, 1, 0.5f, 1, 1f, -1, 1f, -1));
		this.setSize(300, 400);
	}
}
