package sra.jun.goodies.calendar;

import sra.smalltalk.StViewPanel;
import sra.smalltalk.WindowSpecLayout;

/**
 * JunCalendarTimeIntervalViewAwt class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on Jun472 for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarTimeIntervalViewAwt.java,v 6.8 2004/04/15 06:27:55 nisinaka Exp $
 */
public class JunCalendarTimeIntervalViewAwt
	extends StViewPanel
	implements JunCalendarTimeIntervalView {
	protected JunCalendarTimeViewAwt fromView;
	protected JunCalendarTimeViewAwt toView;
	/**
	 * Create instance.
	 *
	 * @param aCalendarTimeInterval JunCalendarTimeInterval
	 * @category instance creation
	 */
	public JunCalendarTimeIntervalViewAwt(JunCalendarTimeIntervalModel aCalendarTimeIntervalModel) {
		super(aCalendarTimeIntervalModel);
	}

	/**
	 * Answer a fromView.
	 *
	 * @return JunCalendarTimeViewAwt
	 * @category accessing
	 */
	public JunCalendarTimeViewAwt fromView() {
		if (fromView == null) {
			fromView =
				new JunCalendarTimeViewAwt(
					this.getModel().fromCalendarTimeModel());
		}
		return fromView;
	}

	/**
	 * Answer a toView.
	 *
	 * @return JunCalendarTimeViewAwt
	 * @category accessing
	 */
	public JunCalendarTimeViewAwt toView() {
		if (toView == null) {
			toView =
				new JunCalendarTimeViewAwt(
					this.getModel().toCalendarTimeModel());
		}
		return toView;
	}

	/**
	* Get model.
	*
	* @return JunCalendarTimeModel
	 * @category accessing
	*/
	public JunCalendarTimeIntervalModel getModel() {
		return (JunCalendarTimeIntervalModel) this.model();
	}

	/**
	 * Build this component.
	 * @category interface opening
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.fromView(), WindowSpecLayout.Position(0f, 1, 0f, 1, 1f, -1, 0.5f, -1));
		this.add(this.toView(), WindowSpecLayout.Position(0f, 1, 0.5f, 1, 1f, -1, 1f, -1));
		this.setSize(150, 400);
	}
}
