package sra.jun.goodies.itemlist;

import sra.smalltalk.StBlockClosure;
import sra.jun.system.support.JunSystem;

/**
 * JunChoiceListDialogTestExamples class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2003/12/15 (by Mitsuhiro Asada)
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on Jun465 for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunChoiceListDialogTestExamples.java,v 1.7 2004/04/15 06:27:58 nisinaka Exp $
 */
public class JunChoiceListDialogTestExamples extends JunItemListDialogTestExamples {
	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunChoiceListDialogTestExamples();
	}

	/**
	 * Example1 : test for a JunChoiceListDialog.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		Object[] answer = JunChoiceListDialog.Request_labels_checks_(JunSystem.$String("Choose items."), _StringArray, JunItemListTestExamples._CheckArray);
		_PrintObjects_(answer);
		return true;
	}

	/**
	 * Example2 : test for a JunChoiceListDialog.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		Object[] answer = JunChoiceListDialog.Request_labels_checks_onAccept_onCancel_(JunSystem.$String("Choose items."), _StringArray, JunItemListTestExamples._CheckArray, new StBlockClosure() {
			public Object value_(Object anObject) {
				JunItemListModel model = (JunItemListModel) anObject;
				System.out.print(JunSystem.$String("Accept button was pressed."));
				System.out.print(" \t");
				_PrintObjects_(model.value());
				return Boolean.TRUE;
			}
		}, new StBlockClosure() {
			public Object value_(Object anObject) {
				JunItemListModel model = (JunItemListModel) anObject;
				System.out.print(JunSystem.$String("Cancel button was pressed."));
				System.out.print(" \t");
				_PrintObjects_(model.value());
				return Boolean.TRUE;
			}
		});
		_PrintObjects_(answer);
		return true;
	}

	/**
	 * Example3 : test for a JunChoiceListDialog.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example3() {
		Object[] answer = JunChoiceListDialog.Request_labels_checks_locks_(JunSystem.$String("Choose items."), _StringArray, JunItemListTestExamples._CheckArray, JunItemListTestExamples._LockArray);
		_PrintObjects_(answer);
		return true;
	}
}
