package sra.jun.goodies.nib;

import sra.smalltalk.StRectangle;
import sra.smalltalk.StView;

/**
 * JunNibChoiceView interface
 * 
 *  @author    Nobuto Matsubara
 *  @created   2004/03/19 (By Nobuto Matsubara)
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on Jun519 for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunNibChoiceView.java,v 6.1 2004/04/15 06:28:00 nisinaka Exp $
 */
public interface JunNibChoiceView extends StView {

	/**
	 * Answer my model as JunNibChoice.
	 * 
	 * @return sra.jun.goodies.nib.JunNibChoice
	 * @category model accessing
	 */
	public JunNibChoice getNibChoice();

	/**
	 * Answer the area of nib shape.
	 * 
	 * @return sra.smalltalk.StRectangle
	 * @category accessing
	 */
	public StRectangle nibShapeArea();

	/**
	 * Answer the area of nib width.
	 * 
	 * @return sra.smalltalk.StRectangle
	 * @category accessing
	 */
	public StRectangle nibWidthArea();

	/**
	 * Answer the string of nib width.
	 * 
	 * @return sra.smalltalk.StRectangle
	 * @category accessing
	 */
	public String nibWidthString();

}
