package sra.jun.goodies.nib;

import java.awt.Window;
import sra.smalltalk.StViewPanel;
import sra.smalltalk.WindowSpecLayout;
import sra.jun.goodies.colors.JunColorChoiceViewAwt;

/**
 * JunNibChoiceWithColorViewAwt class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2004/03/26 (By Nobuto Matsubara)
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on Jun538 for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunNibChoiceWithColorViewAwt.java,v 6.1 2004/04/15 06:28:00 nisinaka Exp $
 */
public class JunNibChoiceWithColorViewAwt extends StViewPanel implements JunNibChoiceWithColorView {

	protected JunColorChoiceViewAwt colorChoiceView;
	protected StViewPanel nibChoiceView;

	/**
	 * Create a new instance of JunNibChoiceWithColorViewAwt and initialize it.
	 * 
	 * @param aModel sra.jun.goodies.nib.JunNibColorWithColorViewAwt
	 * @category Instance creation
	 */
	public JunNibChoiceWithColorViewAwt(JunNibChoiceWithColor aModel) {
		super(aModel);
	}

	/**
	 * Answer my model as JunNibChoiceWithColor.
	 * 
	 * @return sra.jun.goodies.nib.JunNibChoiceWithColor
	 * @see sra.jun.goodies.nib.JunNibChoiceWithColorView#getNibChoiceWithColor()
	 * @category model accessing
	 */
	public JunNibChoiceWithColor getNibChoiceWithColor() {
		return (JunNibChoiceWithColor) this.model();
	}

	/**
	 * Build component.
	 * 
	 * @category interface opening
	 */
	public void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.nibChoiceView(), WindowSpecLayout.Position(0f, 1, 0f, 1, 1f, -1, 1f, -128));
		this.add(this.colorChoiceView(), WindowSpecLayout.Position(0f, 1, 1f, -127, 1f, -1, 1f, -1));
		this.setSize(234, 182);
	}

	/**
	 * Answer a color choice view.
	 * 
	 * @return sra.jun.goodies.colors.JunColorChoiceView
	 * @category user interface
	 */
	public JunColorChoiceViewAwt colorChoiceView() {
		if (colorChoiceView == null) {
			colorChoiceView = new JunColorChoiceViewAwt(this.getNibChoiceWithColor().colorModel());
		}
		return colorChoiceView;
	}

	/**
	 * Answer a nib choice view.
	 * 
	 * @return sra.jun.goodies.colors.JunColorChoiceView
	 * @category user interface
	 */
	public StViewPanel nibChoiceView() {
		if (nibChoiceView == null) {
			nibChoiceView = (StViewPanel) JunNibChoiceViewAwt.WithSlider(this.getNibChoiceWithColor());
		}
		return nibChoiceView;
	}

	/**
	 * Set up the keyboard for the view on the window.
	 * 
	 * @param aWindow java.awt.Window
	 * @see sra.smalltalk.StView#_setupKeyboard(java.awt.Window)
	 * @category keyboard
	 */
	public void _setupKeyboard(Window aWindow) {
		this.nibChoiceView()._setupKeyboard(aWindow);
	}

}
