package sra.jun.goodies.sound;

import java.awt.*;
import sra.smalltalk.*;

/**
 * JunSoundWaveMeterView interface
 * 
 *  @author    Hoshi Takanori
 *  @created   2003/08/29 (by Hoshi Takanori)
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on Jun472 for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunSoundWaveMeterView.java,v 6.5 2004/04/15 06:28:03 nisinaka Exp $
 */
public interface JunSoundWaveMeterView extends StView {

	/**
	 * Display on the graphics.
	 * 
	 * @param graphicsContext java.awt.Graphics
	 */
	public void displayOn_(Graphics graphicsContext);

	/**
	 * Display the current position on the graphics context.
	 *
	 * @param graphicsContext java.awt.Graphics
	 * @param key java.lang.Double
	 */
	public void displayOn_currentPosition_(Graphics graphicsContext, Double key);

	/**
	 * Display from startX to endX on the graphics context.
	 *
	 * @param graphicsContext java.awt.Graphics
	 * @param startX int
	 * @param endX int
	 */
	public void displayOn_from_to_(Graphics graphicsContext, int startX, int endX);
}
