package sra.jun.goodies.track;

import java.awt.*;
import sra.smalltalk.*;

/**
 * JunSimpleSliderView interface
 * 
 *  @author    Hoshi Takanori
 *  @created   2003/08/27 (by Hoshi Takanori)
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on Jun472 for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunSimpleSliderView.java,v 6.5 2004/04/15 06:28:03 nisinaka Exp $
 */
public interface JunSimpleSliderView extends StView {

	public static final Color Gray20 = new Color(51, 51, 51);
	public static final Color Gray70 = new Color(178, 178, 178);
	public static final Color Gray80 = new Color(204, 204, 204);
	public static final Color Gray90 = new Color(229, 229, 229);

	/**
	 * Display on the graphics.
	 * 
	 * @param graphicsContext
	 */
	public void displayOn_(Graphics graphicsContext);

	/**
	 * Display the slider on the graphics context.
	 *
	 * @param graphicsContext java.awt.Graphics
	 */
	public void displaySliderOn_(Graphics graphicsContext);

	/**
	 * Answer the current model as a JunSimpleSliderModel.
	 * 
	 * @return sra.jun.goodies.track.JunSimpleSliderModel
	 */
	public JunSimpleSliderModel getSimpleSliderModel();

	/**
	 * Set the new model value via view.
	 * 
	 * @param x
	 * @param y
	 */
	public void setModelValue_(int x, int y);

	/**
	 * Answer the current slider area.
	 * 
	 * @return StRectangle
	 */
	public StRectangle sliderArea();

	/**
	 * Answer the current slider rectangle.
	 * 
	 * @return StRectangle
	 */
	public StRectangle sliderRectangle();
}
