package sra.jun.opengl.flux;

import java.awt.Dimension;
import sra.smalltalk.StModel;
import sra.smalltalk.WindowSpecLayout;
import sra.jun.goodies.button.JunButtonViewSwing;
import sra.jun.goodies.track.JunTrackSliderViewSwing;
import sra.jun.goodies.wheels.JunThumbWheelViewSwing;
import sra.jun.opengl.display.JunOpenGLDisplayViewSwing;

/**
 * JunOpenGLFluxViewSwing class
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   2000/01/20 (by MATSUDA Ryouichi)
 *  @updated   2003/03/24 (by nisinaka)
 *  @updated   2004/03/16 (by nisinaka)
 *  @version   445 (with StPL6.5) based on Jun490 for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLFluxViewSwing.java,v 6.6 2004/04/15 06:28:08 nisinaka Exp $
 */
public class JunOpenGLFluxViewSwing extends JunOpenGLDisplayViewSwing implements JunOpenGLFluxView {

	/**
	 * Create a new instance of JunOpenGLFluxViewSwing and initialize it.
	 *
	 * @param aFluxModel sra.jun.opengl.flux.JunOpenGLFluxModel
	 */
	public JunOpenGLFluxViewSwing(JunOpenGLFluxModel aFluxModel) {
		super(aFluxModel);
	}

	/**
	 * Answer my model as JunOpenGLFluxModel.
	 * 
	 * @return sra.jun.opengl.flux.JunOpenGLFluxModel
	 * @category model accessing
	 */
	public JunOpenGLFluxModel getOpenGLFluxModel() {
		return (JunOpenGLFluxModel) this.model();
	}

	/**
	 * Answer a default model.
	 * 
	 * @return sra.smalltalk.StModel
	 * @category model accessing
	 */
	protected StModel defaultModel() {
		return new JunOpenGLFluxModel();
	}

	/**
	 * Build this component.
	 * 
	 * @category interface specs
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.openGLView()._onBorderedPanel(), WindowSpecLayout.Position(0f, 20, 0f, 1, 1f, -20, 1f, -39));
		this.add(new JunButtonViewSwing(this.getOpenGLFluxModel().pickButton()), WindowSpecLayout.Position(0f, 1, 0f, 1, 0f, 19, 0f, 19));
		this.add(new JunButtonViewSwing(this.getOpenGLFluxModel().grabButton()), WindowSpecLayout.Position(0f, 1, 0f, 20, 0f, 19, 0f, 38));
		this.add(new JunButtonViewSwing(this.getOpenGLFluxModel().dragButton()), WindowSpecLayout.Position(0f, 1, 0f, 39, 0f, 19, 0f, 57));
		this.add(new JunThumbWheelViewSwing(this.getOpenGLFluxModel().xThumbWheel(), true), WindowSpecLayout.Position(0f, 1, 0.5f, -61, 0f, 19, 0.5f, 61));
		this.add(new JunThumbWheelViewSwing(this.getOpenGLFluxModel().yThumbWheel(), false), WindowSpecLayout.Position(0.5f, -61, 1f, -38, 0.5f, 61, 1f, -20));
		this.add(new JunThumbWheelViewSwing(this.getOpenGLFluxModel().zThumbWheel(), true), WindowSpecLayout.Position(1f, -19, 0.5f, -61, 1f, -1, 0.5f, 61));
		this.add(new JunButtonViewSwing(this.getOpenGLFluxModel().focusButton()), WindowSpecLayout.Position(1f, -19, 0.5f, -80, 1f, -1, 0.5f, -62));
		this.add(new JunButtonViewSwing(this.getOpenGLFluxModel().dollyButton()), WindowSpecLayout.Position(1f, -18, 0.5f, 62, 1f, -2, 0.5f, 78));
		this.add(new JunButtonViewSwing(this.getOpenGLFluxModel().trackerModel().previousButton()), WindowSpecLayout.Position(0f, 1, 1f, -19, 0f, 19, 1f, -1));
		this.add(new JunButtonViewSwing(this.getOpenGLFluxModel().trackerModel().nextButton()), WindowSpecLayout.Position(0f, 20, 1f, -19, 0f, 38, 1f, -1));
		this.add(new JunTrackSliderViewSwing(this.getOpenGLFluxModel().trackerModel()), WindowSpecLayout.Position(0f, 39, 1f, -19, 1f, -39, 1f, -1));
		this.add(new JunButtonViewSwing(this.getOpenGLFluxModel().trackerModel().loopButton()), WindowSpecLayout.Position(1f, -38, 1f, -19, 1f, -20, 1f, -1));
		this.add(new JunButtonViewSwing(this.getOpenGLFluxModel().trackerModel().playButton()), WindowSpecLayout.Position(1f, -19, 1f, -19, 1f, -1, 1f, -1));
		this.setPreferredSize(new Dimension(300, 320));
	}

}
