package sra.jun.opengl.plotter;

import java.awt.*;
import java.util.*;
import sra.jun.geometry.basic.*;
import sra.jun.goodies.pen.*;
import sra.jun.opengl.display.*;
import sra.jun.opengl.objects.*;
import sra.jun.system.framework.JunDialog;
import sra.jun.system.support.JunSystem;
import sra.smalltalk.*;

/**
 * JunOpenGLPlotter class
 * 
 *  @author    Hirotsugu Kondo
 *  @created   1999/01/05 (by Hirotsugu Kondo)
 *  @updated   1999/06/25 (by nisinaka)
 *  @updated   2000/01/19 (by MATSUDA Ryouichi)
 *  @updated   2004/02/05 (by Nobuto Matsubara)
 *  @version   445 (with StPL6.5) based on JunXXX for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLPlotter.java,v 6.9 2004/04/15 06:28:09 nisinaka Exp $
 */
public class JunOpenGLPlotter extends JunOpenGLDisplayModel {

	protected StMenu _plotMenu;
	private boolean canRun;

	/**
	 * DOCUMENT ME!
	 */
	public void browsePrograms() {
		JunDialog.Warn_("can't browse, because it's a runtime version.");
	}

	/**
	 * DOCUMENT ME!
	 */
	public void clearPaper() {
		this.displayObject_(new JunOpenGL3dCompoundObject());
		this.changed_($("clear"));
	}

	/**
	 * DOCUMENT ME!
	 */
	public void curveOfSinAndCos1() {
		final String id = JunOpenGL3dObject.UniqueId();
		final JunOpenGLPlotter this_ = this;

		class S extends Thread {
			public void run() {
				this_._curveOfSinAndCos1_();
			}
		}

		canRun = true;
		S s = new S();
		s.setPriority(Thread.MIN_PRIORITY);
		s.start();
	}

	/**
	 * DOCUMENT ME!
	 */
	public void curveOfSinAndCos2() {
		final String id = JunOpenGL3dObject.UniqueId();
		final JunOpenGLPlotter this_ = this;

		class S extends Thread {
			public void run() {
				this_._curveOfSinAndCos2_();
			}
		}

		S s = new S();
		s.setPriority(Thread.MIN_PRIORITY);
		s.start();
	}

	/**
	 * DOCUMENT ME!
	 */
	public void penExample() {
		final String id = JunOpenGL3dObject.UniqueId();
		final JunOpenGLPlotter this_ = this;

		class S extends Thread {
			public void run() {
				this_._penExample_();
			}
		}

		S s = new S();
		s.setPriority(Thread.MIN_PRIORITY);
		s.start();
	}

	/**
	 * DOCUMENT ME!
	 */
	public void sample1() {
		final String id = JunOpenGL3dObject.UniqueId();
		final JunOpenGLPlotter this_ = this;

		class S extends Thread {
			public void run() {
				this_._sample1_();
			}
		}

		S s = new S();
		s.setPriority(Thread.MIN_PRIORITY);
		s.start();
	}

	/**
	 * DOCUMENT ME!
	 */
	public void sample2() {
		final String id = JunOpenGL3dObject.UniqueId();
		final JunOpenGLPlotter this_ = this;

		class S extends Thread {
			public void run() {
				this_._sample2_();
			}
		}

		S s = new S();
		s.setPriority(Thread.MIN_PRIORITY);
		s.start();
	}

	/**
	 * DOCUMENT ME!
	 */
	public void sample3() {
		final String id = JunOpenGL3dObject.UniqueId();
		final JunOpenGLPlotter this_ = this;

		class S extends Thread {
			public void run() {
				this_._sample3_();
			}
		}

		S s = new S();
		s.setPriority(Thread.MIN_PRIORITY);
		s.start();
	}

	/**
	 * DOCUMENT ME!
	 */
	public void sample4() {
		final String id = JunOpenGL3dObject.UniqueId();
		final JunOpenGLPlotter this_ = this;

		class S extends Thread {
			public void run() {
				this_._sample4_();
			}
		}

		S s = new S();
		s.setPriority(Thread.MIN_PRIORITY);
		s.start();
	}

	/**
	 * DOCUMENT ME!
	 */
	public void sample5() {
		final String id = JunOpenGL3dObject.UniqueId();
		final JunOpenGLPlotter this_ = this;

		class S extends Thread {
			public void run() {
				this_._sample5_();
			}
		}

		S s = new S();
		s.setPriority(Thread.MIN_PRIORITY);
		s.start();
	}

	/**
	 * DOCUMENT ME!
	 */
	public void sample6() {
		final String id = JunOpenGL3dObject.UniqueId();
		final JunOpenGLPlotter this_ = this;

		class S extends Thread {
			public void run() {
				this_._sample6_();
			}
		}

		S s = new S();
		s.setPriority(Thread.MIN_PRIORITY);
		s.start();
	}

	/**
	 * DOCUMENT ME!
	 */
	public void sample7() {
		final String id = JunOpenGL3dObject.UniqueId();
		final JunOpenGLPlotter this_ = this;

		class S extends Thread {
			public void run() {
				this_._sample7_();
			}
		}

		S s = new S();
		s.setPriority(Thread.MIN_PRIORITY);
		s.start();
	}

	/**
	 * DOCUMENT ME!
	 */
	public void sample8() {
		final String id = JunOpenGL3dObject.UniqueId();
		final JunOpenGLPlotter this_ = this;

		class S extends Thread {
			public void run() {
				this_._sample8_();
			}
		}

		S s = new S();
		s.setPriority(Thread.MIN_PRIORITY);
		s.start();
	}

	/**
	 * DOCUMENT ME!
	 */
	public void sample9() {
		final String id = JunOpenGL3dObject.UniqueId();
		final JunOpenGLPlotter this_ = this;

		class S extends Thread {
			public void run() {
				this_._sample9_();
			}
		}

		S s = new S();
		s.setPriority(Thread.MIN_PRIORITY);
		s.start();
	}

	/**
	 * DOCUMENT ME!
	 */
	public void sampleA() {
		final String id1 = JunOpenGL3dObject.UniqueId();
		final String id2 = JunOpenGL3dObject.UniqueId();
		final JunOpenGLPlotter this_ = this;

		class S1 extends Thread {
			public void run() {
				this_._sample4_();
			}
		}

		class S2 extends Thread {
			public void run() {
				this_._sample9_();
			}
		}

		S1 s1 = new S1();
		S2 s2 = new S2();
		s1.setPriority(Thread.MIN_PRIORITY);
		s2.setPriority(Thread.MIN_PRIORITY);
		s1.start();
		s2.start();
	}

	/**
	 * DOCUMENT ME!
	 */
	private void _curveOfSinAndCos1_() {
		this.clearPaper();

		JunPen pen1 = this.newPen();
		pen1.color_(Color.red);

		JunPen pen2 = this.newPen();
		pen2.color_(Color.blue);

		double pi = Math.PI;
		JunPoint scale = new Jun2dPoint(30, 30);
		pen1.up();
		pen2.up();

		for (double n = -3; n <= 3; n = n + 0.06) {
			if (!canRun) {
				break;
			}
			double x = n * pi;
			double y1 = Math.sin(n * pi);
			double y2 = Math.cos(n * pi);
			pen1.goto_(JunPenLocation.FromPoint_(new Jun2dPoint(x, y1)).scaledBy_(scale));

			if (pen1.isUp()) {
				pen1.down();
			}

			pen2.goto_(JunPenLocation.FromPoint_(new Jun2dPoint(x, y2)).scaledBy_(scale));

			if (pen2.isUp()) {
				pen2.down();
			}
		}
	}

	/**
	 * DOCUMENT ME!
	 */
	private void _curveOfSinAndCos2_() {
		this.clearPaper();

		JunPen pen0 = this.newPen();
		pen0.color_(Color.gray);

		JunPen pen1 = this.newPen();
		pen1.color_(Color.red);

		JunPen pen2 = this.newPen();
		pen2.color_(Color.blue);

		double pi = Math.PI;
		JunPoint scale = new Jun2dPoint(30, 30);
		pen0.location_(JunPenLocation.FromPoint_(new Jun2dPoint(-3 * pi, 0)).scaledBy_(scale));
		pen0.goto_(JunPenLocation.FromPoint_(new Jun2dPoint(3 * pi, 0)).scaledBy_(scale));
		pen0.location_(JunPenLocation.FromPoint_(new Jun2dPoint(0, -1)).scaledBy_(scale));
		pen0.goto_(JunPenLocation.FromPoint_(new Jun2dPoint(0, 1)).scaledBy_(scale));
		pen1.up();
		pen2.up();

		for (double n = -3; n <= 3; n = n + 0.06) {
			if (!canRun) {
				break;
			}
			double x = n * pi;
			double y1 = Math.sin(n * pi);
			double y2 = Math.cos(n * pi);
			pen1.goto_(JunPenLocation.FromPoint_(new Jun2dPoint(x, y1)).scaledBy_(scale));

			if (pen1.isUp()) {
				pen1.down();
			}

			pen2.goto_(JunPenLocation.FromPoint_(new Jun2dPoint(x, y2)).scaledBy_(scale));

			if (pen2.isUp()) {
				pen2.down();
			}
		}
	}

	/**
	 * Answer the default file menu for JunOpenGLPlotter.
	 * 
	 * @return sra.smalltalk.StMenu
	 */
	protected StMenu _defaultFileMenu() {
		StMenu defaultFileMenu = new StMenu(JunSystem.$String("File"));

		// New
		defaultFileMenu.add(createMenuItem(JunSystem.$String("New"), "newModel"));

		// Save as...
		StMenu saveAsMenu = new StMenu(JunSystem.$String("Save as..."));
		saveAsMenu.add(createMenuItem("LST 1.0...", "saveLST10"));
		saveAsMenu.add(createMenuItem("VRML1.0...", "saveWRL10"));
		saveAsMenu.add(createMenuItem("VRML2.0...", "saveWRL97"));
		defaultFileMenu.add(saveAsMenu);

		//
		defaultFileMenu.addSeparator();

		// Save as image...
		defaultFileMenu.add(createMenuItem(JunSystem.$String("Save as image..."), "saveAsImage"));

		//
		defaultFileMenu.addSeparator();

		// Quit
		defaultFileMenu.add(createMenuItem(JunSystem.$String("Quit"), "quitDoing"));

		return defaultFileMenu;
	}

	/**
	 * Answer the default misc menu for JunOpenGLDisplayModel.
	 * 
	 * @return sra.smalltalk.StMenu
	 */
	protected StMenu _defaultMiscMenu() {
		StMenu defaultMiscMenu = new StMenu(JunSystem.$String("Misc"));

		// Spawn
		defaultMiscMenu.add(createMenuItem(JunSystem.$String("Spawn"), "spawnObject"));

		// Viewport
		defaultMiscMenu.add(createMenuItem(JunSystem.$String("Viewport"), "spawnViewport"));

		return defaultMiscMenu;
	}

	/**
	 * Answer the default plot menu for JunOpenGLPlotter.
	 * 
	 * @return sra.smalltalk.StMenu
	 */
	protected StMenu _defaultPlotMenu() {
		StMenu defaultPlotMenu = new StMenu(JunSystem.$String("Plot"));

		defaultPlotMenu.add(createMenuItem(JunSystem.$String("Clear"), "clearPaper"));

		StMenu executePlotMenu = new StMenu(JunSystem.$String("Execute") + "...");
		String[] selectors = this.programSelectors();
		for (int index = 0; index < selectors.length; index++) {
			String selector = selectors[index];
			executePlotMenu.add(createMenuItem(selector, selector));
		}

		defaultPlotMenu.add(executePlotMenu);

		return defaultPlotMenu;
	}

	/**
	 * DOCUMENT ME!
	 */
	private void _penExample_() {
		this.clearPaper();

		JunPen aPen = this.newPen();
		aPen.nib_(4);
		aPen.color_(Color.gray);

		for (int i = 1; i < 51; i++) {
			if (!canRun) {
				break;
			}
			aPen.go_(i * 4);
			aPen.turn_(89);
		}
	}

	/**
	 * Answer my plot menu.
	 *
	 * @return sra.smalltalk.StMenu
	 */
	protected StMenu _plotMenu() {
		if (_plotMenu == null) {
			_plotMenu = this._defaultPlotMenu();
		}
		return _plotMenu;
	}

	/**
	 * DOCUMENT ME!
	 */
	private void _sample1_() {
		this.clearPaper();

		JunPen aPen = this.newPen();
		aPen.color_(Color.red);

		for (int i = 0; i < 8; i++) {
			for (int j = 0; j < 3; j++) {
				if (!canRun) {
					break;
				}
				aPen.go_(100);
				aPen.turn_(120);
			}

			aPen.turn_(45);
		}
	}

	/**
	 * DOCUMENT ME!
	 */
	private void _sample2_() {
		this.clearPaper();

		JunPen aPen = this.newPen();
		aPen.nib_(3);
		aPen.color_(Color.red);
		aPen.spiral_angle_(200, 144);
	}

	/**
	 * DOCUMENT ME!
	 */
	private void _sample3_() {
		this.clearPaper();

		JunPen aPen = this.newPen();
		aPen.color_(Color.red);
		aPen.dragon_distance_(9, 5);
	}

	/**
	 * DOCUMENT ME!
	 */
	private void _sample4_() {
		this.clearPaper();

		JunPen aPen = this.newPen();
		aPen.color_(Color.red);
		aPen.mandala_diameter_(24, 250);
	}

	/**
	 * DOCUMENT ME!
	 */
	private void _sample5_() {
		this.clearPaper();

		final JunPen pen1 = this.newPen();
		pen1.color_(Color.red);

		final JunPen pen2 = this.newPen();
		pen2.color_(Color.red);

		final JunPen pen3 = this.newPen();
		pen3.color_(Color.red);

		final JunPen pen4 = this.newPen();
		pen4.color_(Color.red);

		final JunPen pen5 = this.newPen();
		pen5.color_(Color.red);
		pen1.location_(new Jun2dPoint(-75, -75));
		pen2.location_(new Jun2dPoint(75, -75));
		pen3.location_(new Jun2dPoint(75, 75));
		pen4.location_(new Jun2dPoint(-75, 75));
		pen5.location_(new Jun2dPoint(0, 0));
		pen1.spiral_angle_(100, 88);
		pen2.spiral_angle_(100, 88);
		pen3.spiral_angle_(100, 88);
		pen4.spiral_angle_(100, 88);
		pen5.spiral_angle_(100, 88);
	}

	/**
	 * DOCUMENT ME!
	 */
	private void _sample6_() {
		final String id1 = JunOpenGL3dObject.UniqueId();
		final String id2 = JunOpenGL3dObject.UniqueId();
		final String id3 = JunOpenGL3dObject.UniqueId();
		final String id4 = JunOpenGL3dObject.UniqueId();
		final String id5 = JunOpenGL3dObject.UniqueId();
		this.clearPaper();

		final JunPen pen1 = this.newPen();
		pen1.color_(Color.red);

		final JunPen pen2 = this.newPen();
		pen2.color_(Color.red);

		final JunPen pen3 = this.newPen();
		pen3.color_(Color.red);

		final JunPen pen4 = this.newPen();
		pen4.color_(Color.red);

		final JunPen pen5 = this.newPen();
		pen5.color_(Color.red);
		pen1.location_(new Jun2dPoint(-75, -75));
		pen2.location_(new Jun2dPoint(75, -75));
		pen3.location_(new Jun2dPoint(75, 75));
		pen4.location_(new Jun2dPoint(-75, 75));
		pen5.location_(new Jun2dPoint(0, 0));

		final JunOpenGLPlotter this_ = this;

		class S1 extends Thread {
			public void run() {
				pen1.spiral_angle_(100, 88);
			}
		}

		class S2 extends Thread {
			public void run() {
				pen2.spiral_angle_(100, 88);
			}
		}

		class S3 extends Thread {
			public void run() {
				pen3.spiral_angle_(100, 88);
			}
		}

		class S4 extends Thread {
			public void run() {
				pen4.spiral_angle_(100, 88);
			}
		}

		class S5 extends Thread {
			public void run() {
				pen5.spiral_angle_(100, 88);
			}
		}

		S1 s1 = new S1();
		S2 s2 = new S2();
		S3 s3 = new S3();
		S4 s4 = new S4();
		S5 s5 = new S5();
		s1.start();
		s2.start();
		s3.start();
		s4.start();
		s5.start();
	}

	/**
	 * DOCUMENT ME!
	 */
	private void _sample7_() {
		this.clearPaper();

		JunPen aPen = this.newPen();
		aPen.nib_(3);

		double[] location = new double[3];
		location[0] = -50;
		location[1] = -50;
		location[2] = -50;
		aPen.location_(JunPenLocation.FromArray_(location));
		aPen.direction_(JunPenDirection.Zero());
		aPen.color_(Color.blue);

		for (int i = 1; i < 5; i++) {
			if (!canRun) {
				break;
			}
			aPen.go_(100);
			aPen.turn_(90);
		}

		location[0] = 50;
		location[1] = -50;
		location[2] = -50;
		aPen.location_(JunPenLocation.FromArray_(location));
		aPen.direction_(JunPenDirection.Longitude_(90));
		aPen.color_(Color.blue);

		for (int i = 1; i < 5; i++) {
			aPen.go_(100);
			aPen.tilt_(90);
		}

		location[0] = -50;
		location[1] = 50;
		location[2] = -50;
		aPen.location_(JunPenLocation.FromArray_(location));
		aPen.direction_(JunPenDirection.Zero());
		aPen.color_(Color.blue);

		for (int i = 1; i < 5; i++) {
			aPen.go_(100);
			aPen.tilt_(90);
		}
	}

	/**
	 * DOCUMENT ME!
	 */
	private void _sample8_() {
		this.clearPaper();

		final JunPen aPen = this.newPen();
		aPen.nib_(2);

		double[] location = new double[3];
		location[0] = -50;
		location[1] = -50;
		location[2] = -50;
		aPen.location_(JunPenLocation.FromArray_(location));
		aPen.direction_(JunPenDirection.Zero());
		aPen.color_(Color.red);
		aPen.fill_(new StBlockClosure() {
			public Object value() {
				for (int i = 1; i < 5; i++) {
					if (!canRun) {
						break;
					}
					aPen.go_(100);
					aPen.turn_(90);
				}

				return null;
			}
		});
		location[0] = 50;
		location[1] = -50;
		location[2] = -50;
		aPen.location_(JunPenLocation.FromArray_(location));
		aPen.direction_(JunPenDirection.Longitude_(90));
		aPen.color_(Color.green);
		aPen.fill_(new StBlockClosure() {
			public Object value() {
				for (int i = 1; i < 5; i++) {
					aPen.go_(100);
					aPen.tilt_(90);
				}

				return null;
			}
		});
		location[0] = -50;
		location[1] = 50;
		location[2] = -50;
		aPen.location_(JunPenLocation.FromArray_(location));
		aPen.direction_(JunPenDirection.Zero());
		aPen.color_(Color.blue);
		aPen.fill_(new StBlockClosure() {
			public Object value() {
				for (int i = 1; i < 5; i++) {
					aPen.go_(100);
					aPen.tilt_(90);
				}

				return null;
			}
		});
	}

	/**
	 * DOCUMENT ME!
	 */
	private void _sample9_() {
		this.clearPaper();

		final JunPen aPen = this.newPen();
		aPen.nib_(1);
		aPen.color_(Color.blue);

		StBlockClosure aBlock = new StBlockClosure() {
			public Object value_(Object anObject) {
				int sign = ((Integer) anObject).intValue();
				aPen.home();

				for (int i = 1; i < 51; i++) {
					if (!canRun) {
						break;
					}
					JunPenLocation from = aPen.location();
					aPen.up();
					aPen.go_(i * 4 * sign);
					aPen.goto_(aPen.location().plus_(JunPenLocation.X_y_z_(0, 2 * sign, 0)));

					JunPenLocation to = aPen.location();
					aPen.location_(from);
					aPen.down();
					aPen.goto_(to);
					aPen.tilt_(89);
				}

				return null;
			}
		};

		aBlock.value_(new Integer(1));
		aBlock.value_(new Integer(-1));
	}

	/**
	 * Create the menubar for JunOpenGLDisplay.
	 * 
	 * @return sra.smalltalk.StMenuModel
	 */
	protected StMenuModel defaultMenu() {
		StMenuModel rootMenu = new StMenuModel();

		rootMenu.add(this._fileMenu());
		rootMenu.add(this._editMenu());
		rootMenu.add(this._viewMenu());
		rootMenu.add(this._lightMenu());
		rootMenu.add(this._plotMenu());
		rootMenu.add(this._miscMenu());

		return rootMenu;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param anArray java.util.Vector
	 */
	private void interpretAs3dObject_(Vector anArray) {
		if (anArray.isEmpty()) {
			return;
		}

		StSymbol tagSymbol = (StSymbol) anArray.elementAt(0);

		if (tagSymbol == $("stroke")) {
			int nibWidth = ((Integer) anArray.elementAt(1)).intValue();
			Color colorValue = (Color) anArray.elementAt(2);
			JunPenLocation fromPoint = (JunPenLocation) anArray.elementAt(3);
			JunPenLocation toPoint = (JunPenLocation) anArray.elementAt(4);
			Jun3dPoint[] locationArray = new Jun3dPoint[2];
			locationArray[0] = JunPenLocation.Coerce_(fromPoint)._as3dPoint();
			locationArray[1] = JunPenLocation.Coerce_(toPoint)._as3dPoint();

			JunOpenGL3dPolyline aPolyline = (JunOpenGL3dPolyline) JunOpenGL3dPolyline.Vertexes_(locationArray);
			aPolyline.paint_(colorValue);
			aPolyline.lineWidth_(nibWidth);
			((JunOpenGL3dCompoundObject) this.displayObject()).add_(aPolyline);
		}

		if (tagSymbol == $("fill")) {
			Color colorValue = (Color) anArray.elementAt(1);
			Vector locationArray = (Vector) anArray.elementAt(2);
			Jun3dPoint[] vertexes = new Jun3dPoint[locationArray.size()];

			for (int index = 0; index < locationArray.size(); index++) {
				vertexes[index] = JunPenLocation.Coerce_(locationArray.elementAt(index))._as3dPoint();
			}

			JunOpenGL3dPolygon aPolygon = (JunOpenGL3dPolygon) JunOpenGL3dPolygon.Vertexes_(vertexes);
			aPolygon.paint_(colorValue);
			((JunOpenGL3dCompoundObject) this.displayObject()).add_(aPolygon);
		}
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return sra.jun.goodies.pen.JunPen
	 */
	private JunPen newPen() {
		JunPen aPen = new JunPen();
		final JunOpenGLPlotter this_ = this;
		aPen.compute_(new StBlockClosure() {
			public Object value_(Object anObject) {
				this_.interpretAs3dObject_((Vector) anObject);
				this_.changed_with_($("draw"), anObject);

				return null;
			}
		});
		aPen.addDependent_(this);

		return aPen;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return java.lang.String[]
	 */
	private String[] programSelectors() {
		String[] programSelectors = new String[13];
		programSelectors[0] = "curveOfSinAndCos1";
		programSelectors[1] = "curveOfSinAndCos2";
		programSelectors[2] = "penExample";
		programSelectors[3] = "sample1";
		programSelectors[4] = "sample2";
		programSelectors[5] = "sample3";
		programSelectors[6] = "sample4";
		programSelectors[7] = "sample5";
		programSelectors[8] = "sample6";
		programSelectors[9] = "sample7";
		programSelectors[10] = "sample8";
		programSelectors[11] = "sample9";
		programSelectors[12] = "sampleA";

		return programSelectors;
	}

	/**
	 * Answer a window title.
	 * 
	 * @return java.lang.String
	 */
	protected String windowTitle() {
		return "OpenGL Plotter";
	}

	/**
	 * Stop a thread.
	 */
	public void stop() {
		canRun = false;
	}
}
