package sra.jun.topology.abstracts;

import sra.jun.topology.elements.JunBody;

/*
 * @(#)JunTopologicalElementProxy.java        1.0 98/9/15
 */
import sra.smalltalk.SmalltalkException;

/**
 * JunTopologicalElementProxy class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on JunXXX for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTopologicalElementProxy.java,v 6.5 2004/04/15 06:28:13 nisinaka Exp $
 */
public abstract class JunTopologicalElementProxy extends JunTopology implements JunTopologicalElementOrProxy {

	/**
	 * Convert the receiver as a proxy in aBody.
	 * 
	 * @param aBody sra.jun.topology.elements.JunBody
	 * 
	 * @return sra.jun.topology.abstracts.JunTopologicalElementProxy
	 */
	public JunTopologicalElementProxy asProxyIn_(JunBody aBody) {
		return this.asProxyIn_advise_(aBody, this);
	}

	/**
	 * Convert the receiver as a proxy in aBody.
	 * 
	 * @param aBody sra.jun.topology.elements.JunBody
	 * @param aTopologicalElementProxy
	 *        sra.jun.topology.abstracts.JunTopologicalElementProxy
	 * 
	 * @return sra.jun.topology.abstracts.JunTopologicalElementProxy
	 */
	public JunTopologicalElementProxy asProxyIn_advise_(JunBody aBody, JunTopologicalElementProxy aTopologicalElementProxy) {
		return this;
	}

	/**
	 * Answer true if the receiver is a kind of geometry, otherwise false.
	 * 
	 * @return boolean
	 */
	public boolean isTopologicalProxy() {
		return true;
	}

	/**
	 * Answer the JunTopologicalElement of aBody corresponds to the receiver.
	 * 
	 * @param aBody sra.jun.topology.elements.JunBody
	 * 
	 * @return sra.jun.topology.abstracts.JunTopologicalElement
	 */
	public JunTopologicalElement value_(JunBody aBody) {
		throw SmalltalkException.SubclassResponsibility();
	}
}
