package sra.jun.vrml.field.sf;

import sra.smalltalk.StSymbol;

/**
 * JunVrmlSFBoolField class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/17 (by nisinaka)
 *  @version   445 (with StPL6.5) based on JunXXX for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlSFBoolField.java,v 6.5 2004/04/15 06:28:18 nisinaka Exp $
 */
public class JunVrmlSFBoolField extends sra.jun.vrml.field.abstracts.JunVrmlSFField {
	protected boolean value;

	/**
	 * Create a JunVrmlSFBoolField and initialize it.
	 * 
	 * @param anObject java.lang.Object
	 */
	public JunVrmlSFBoolField(Object anObject) {
		this((StSymbol) anObject);
	}

	/**
	 * Create a new instance of JunVrmlSFBoolField and initialize it.
	 * 
	 * @param aSymbol sra.smalltalk.StSymbol
	 */
	public JunVrmlSFBoolField(StSymbol aSymbol) {
		this.value_(aSymbol == $("TRUE"));
	}

	/**
	 * Create a new instance of JunVrmlSFBoolField and initialize it.
	 * 
	 * @param booleanValue boolean
	 */
	public JunVrmlSFBoolField(boolean booleanValue) {
		this.value_(booleanValue);
	}

	/**
	 * Answer my value.
	 * 
	 * @return boolean
	 */
	public boolean value() {
		return value;
	}

	/**
	 * Set my value.
	 * 
	 * @param booleanValue boolean
	 */
	public void value_(boolean booleanValue) {
		value = booleanValue;
	}
}
