package sra.jun.vrml.node.abstracts;

import sra.jun.vrml.support.JunVrmlNodeVisitor;

/**
 * JunVrmlNode class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/27 (by nisinaka)
 *  @version   445 (with StPL6.5) based on JunXXX for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlNode.java,v 6.5 2004/04/15 06:28:18 nisinaka Exp $
 */
public abstract class JunVrmlNode extends sra.smalltalk.StObject {

	public static JunVrmlNode Undefined = new JunVrmlNode() {
	};

	/**
	 * Create a new instance of JunVrmlNode and initialize it.
	 * 
	 * @category Instance creation
	 */
	public JunVrmlNode() {
		this.initialize();
	}

	/**
	 * Initialize the JunVrmlNode.
	 * 
	 * @category initialize-release
	 */
	protected void initialize() {
		// Nothing to do.
	}

	/**
	 * Answer true if the receiver is a geometry node, otherwise false.
	 * 
	 * @return boolean
	 * @category testing
	 */
	public boolean isGeometryNode() {
		return false;
	}

	/**
	 * Answer true if the receiver is a grouping node, otherwise false.
	 * 
	 * @return boolean
	 * @category testing
	 */
	public boolean isGroupingNode() {
		return false;
	}

	/**
	 * Answer true if the receiver is a property node, otherwise false.
	 * 
	 * @return boolean
	 * @category testing
	 */
	public boolean isPropertyNode() {
		return false;
	}

	/**
	 * Process the receiver with the visitor.
	 * 
	 * @param aVisitor sra.jun.vrml.support.JunVrmlNodeVisitor
	 * @category enumerating
	 */
	public void nodeDo_(JunVrmlNodeVisitor aVisitor) {
		// Nothing to do.
	}

}
