package sra.jun.vrml.node.grouping10;

import java.util.Vector;
import sra.jun.vrml.node.abstracts.*;
import sra.jun.vrml.support.*;

/**
 * JunVrmlSeparatorNode class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/27 (by nisinaka)
 *  @version   445 (with StPL6.5) based on JunXXX for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlSeparatorNode.java,v 6.5 2004/04/15 06:28:19 nisinaka Exp $
 */
public class JunVrmlSeparatorNode extends JunVrmlAbstractGroupingNode {
	protected JunVrmlNode[] nodes;

	/**
	 * Create a new instance of JunVrmlSeparatorNode and initialize it.
	 * 
	 * @param aCollectionOfNodes java.util.Vector
	 */
	public JunVrmlSeparatorNode(Vector aCollectionOfNodes) {
		this.nodes_(aCollectionOfNodes);
	}

	/**
	 * Process myself with the generator.
	 * 
	 * @param aVisitor sra.jun.vrml.support.JunVrmlNodeVisitor
	 */
	public void nodeDo_(JunVrmlNodeVisitor aVisitor) {
		try {
			aVisitor.perform_with_("doSeparator_", this);
		} catch (Exception e) {
			super.nodeDo_(aVisitor);
		}
	}

	/**
	 * Answer the nodes.
	 * 
	 * @return sra.jun.vrml.node.abstracts.JunVrmlNode[]
	 */
	public JunVrmlNode[] nodes() {
		return nodes;
	}

	/**
	 * Set the nodes.
	 * 
	 * @param aCollection java.util.Vector
	 */
	public void nodes_(Vector aCollection) {
		int size = aCollection.size();
		nodes = new JunVrmlNode[size];
		aCollection.copyInto(nodes);
	}
}
