package sra.qt4jun;

import java.awt.Color;
import sra.smalltalk.StImage;
import sra.jun.system.support.*;

/**
 * JunQTInterfaceTestExamples class
 * 
 *  @author    NISHIHARA Satoshi
 *  @created   2001/01/11 (by NISHIHARA Satoshi)
 *  @updated   N/A
 *  @version   445 (with StPL6.5) based on JunXXX for Smalltalk
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2004 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunQTInterfaceTestExamples.java,v 6.5 2004/04/15 06:28:21 nisinaka Exp $
 */
public class JunQTInterfaceTestExamples extends JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example1() {
		JunQTInterface anInterface = JunQTInterface.Interface();
		int movie = anInterface.openMovie();

		if (movie != 0) {
			int grafPtr = 0;
			anInterface.qtSetMovieGWorld(movie, grafPtr, 0);
			anInterface.qtStartMovie(movie);

			while (!anInterface.isMovieDone(movie)) {
				anInterface.qtMoviesTask(movie, 0);
			}

			anInterface.qtStopMovie(movie);
			anInterface.qtDisposeMovie(movie);
			anInterface.destroyPortAssociation(grafPtr);
		}

		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static boolean Example2() {
		JunQTInterface anInterface = JunQTInterface.Interface();
		int movie = anInterface.openMovie();

		byte[] data = null;
		if (movie != 0) {
			int duration = anInterface.qtGetMovieDuration(movie);
			data = anInterface.convertMovieToSoundData(movie, 0, duration);
		}

		if (data != null) {
			int width = 640, height = 256, color = Color.black.getRGB();
			int[][] array = anInterface.compactSoundData(data, width);
			StImage image = new StImage(width, height);
			for (int i = 0; i < width; ++i) {
				int high = array[0][i], low = array[1][i];
				for (int j = low; j <= high; ++j) {
					image.setPixel(i, j, color);
				}
			}
			image._display();
		}

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunQTInterfaceTestExamples();
	}
}
