package sra.smalltalk;

import java.lang.reflect.*;

/**
 * SmalltalkTestExamples class
 * 
 *  @author    nisinaka
 *  @created   1999/03/12 (by nisinaka)
 *  @updated   2003/03/17 (by nisinaka)
 *  @version   6.5
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: SmalltalkTestExamples.java,v 6.5 2004/04/15 06:28:21 nisinaka Exp $
 */
public abstract class SmalltalkTestExamples extends StObject {

	/**
	 * Execute all the methods which name begins with "Example".
	 */
	public SmalltalkTestExamples() {
		ExecuteMethods(this.getClass(), "Example");
	}

	/**
	 * Execute all the methods specified with the String.
	 * 
	 * @param aString java.lang.String
	 */
	public SmalltalkTestExamples(String aString) {
		ExecuteMethods(this.getClass(), aString);
	}

	/**
	 * Execute all methods specified with the method name.
	 * 
	 * @param aClass DOCUMENT ME!
	 * @param methodName java.lang.String
	 * 
	 * @throws SmalltalkException DOCUMENT ME!
	 */
	public static final void ExecuteMethods(Class aClass, String methodName) {
		try {
			Method[] methodList = aClass.getDeclaredMethods();

			for (int i = 0; i < methodList.length; i++) {
				Method method = methodList[i];

				if (method.getName().startsWith(methodName)) {
					System.out.println(method.getName());

					Boolean result = (Boolean) method.invoke(null, null);

					System.out.println("-> " + result);
				}
			}
		} catch (Exception e) {
			throw new SmalltalkException(e);
		}
	}
}
