package sra.smalltalk;

import java.lang.reflect.*;

/**
 * StBlockClosure class
 * 
 *  @author    He Weijie
 *  @created   1998/08/06 (by He Weijie)
 *  @updated   N/A
 *  @version   6.5
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: StBlockClosure.java,v 6.6 2004/04/15 06:28:21 nisinaka Exp $
 */
public class StBlockClosure extends StObject {

	/**
	 * Just return the number of arguments.
	 * 
	 * @return int
	 */
	public int numArgs() {
		Class myClass = this.getClass();
		if (myClass == StBlockClosure.class) {
			return 0;
		}

		Method[] myMethods = myClass.getDeclaredMethods();
		if (myMethods.length != 1) {
			this.error_("There should be only one method defined for StBlockClosure.");
		}

		return myMethods[0].getParameterTypes().length;
	}

	/**
	 * This is a abstract method for value
	 * 
	 * @return java.lang.Object
	 * 
	 * @throws SmalltalkException DOCUMENT ME!
	 */
	public Object value() throws SmalltalkException {
		return null;
	}

	/**
	 * This is a abstract method for value:
	 * 
	 * @param argument java.lang.Object
	 * 
	 * @return java.lang.Object
	 * 
	 * @throws SmalltalkException DOCUMENT ME!
	 */
	public Object value_(Object argument) throws SmalltalkException {
		return null;
	}

	/**
	 * This is a abstract method for value: value:
	 * 
	 * @param argument1 java.lang.Object
	 * @param argument2 java.lang.Object
	 * 
	 * @return java.lang.Object
	 * 
	 * @throws SmalltalkException DOCUMENT ME!
	 */
	public Object value_value_(Object argument1, Object argument2) throws SmalltalkException {
		return null;
	}

	/**
	 * This is a abstract method for value: value: value:
	 * 
	 * @param argument1 java.lang.Object
	 * @param argument2 java.lang.Object
	 * @param argument3 java.lang.Object
	 * 
	 * @return java.lang.Object
	 * 
	 * @throws SmalltalkException DOCUMENT ME!
	 */
	public Object value_value_value_(Object argument1, Object argument2, Object argument3) throws SmalltalkException {
		return null;
	}

	/**
	 * This is a abstract method for valueWithArguments:
	 * 
	 * @param anArray java.lang.Object[]
	 * 
	 * @return java.lang.Object
	 */
	public Object valueWithArguments_(Object[] anArray) {
		return null;
	}
}
