package sra.smalltalk;

/**
 * StSortedCollectionTestExamples class
 * 
 *  @author    nisinaka
 *  @created   1998/12/02 (by nisinaka)
 *  @updated   N/A
 *  @version   6.5
 *  @copyright 1999-2004 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2004 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: StSortedCollectionTestExamples.java,v 6.5 2004/04/15 06:28:22 nisinaka Exp $
 */
public class StSortedCollectionTestExamples extends SmalltalkTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return boolean
	 */
	public static final boolean Example1() {
		StBlockClosure sortBlock = new StBlockClosure() {
			public Object value_value_(Object e1, Object e2) {
				return new Boolean(((Number) e1).intValue() <= ((Number) e2).intValue());
			}
		};

		StSortedCollection collection = new StSortedCollection(sortBlock);

		collection.add_(new Integer(0));
		collection.add_(new Integer(4));
		collection.add_(new Integer(5));
		collection.add_(new Integer(3));
		collection.add_(new Integer(2));
		collection.add_(new Integer(1));

		Object[] array = collection._asArray();

		for (int i = 0; i < array.length; i++) {
			System.out.println(i);

			if (((Number) array[i]).intValue() != i) {
				return false;
			}
		}

		return true;
	}

	/**
	 * Execute all examles.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new StSortedCollectionTestExamples();
	}
}
